#pragma once
#include <fstream>
using namespace std;
#define _maxn 310
#define _qSize 100000
int n;
int tnx,tny;
unsigned char mas[3*_maxn][3*_maxn];
unsigned char vis[3*_maxn][3*_maxn];
int lev[3*_maxn][3*_maxn];
unsigned char clr[256];
struct point
{
	int x,y,px,py,level;
} q[_qSize];
void bfs(int y,int x,int color,int &tp)
{

	int l=0;int r=0;
	vis[y][x]=1;
	lev[y][x]=1;
	q[r].x=x;
	q[r].level=1;
	q[r++].y=y;
	while (l!=r)
	{
		point t;
		t.x=q[l].x;
		t.y=q[l].y;
		t.px=q[l].px;
		t.py=q[l].py;
		l++;
		if (l>_qSize) l%=_qSize;
		if (t.x>0 && (t.y!=t.py || t.x-1!=t.px) && mas[t.y][t.x-1]==color)
		{
			if (vis[t.y][t.x-1]==1) {if (lev[t.y][t.x]!=lev[t.y][t.x-1]) tp=1;} else{
			vis[t.y][t.x-1]=1;
			lev[t.y][t.x-1]=lev[t.y][t.x];
			q[r].x=t.x-1;
			q[r].y=t.y;
			q[r].py=t.y;
			q[r].px=t.x;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
		if (t.x<3*n-1 && (t.y!=t.py || t.x+1!=t.px) && mas[t.y][t.x+1]==color)
		{
			if (vis[t.y][t.x+1]==1) {if (lev[t.y][t.x]!=lev[t.y][t.x+1]) tp=1;} else{
			vis[t.y][t.x+1]=1;
			lev[t.y][t.x+1]=lev[t.y][t.x];
			q[r].x=t.x+1;
			q[r].y=t.y;
			q[r].py=t.y;
			q[r].px=t.x;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
		if (t.y>0 && (t.y-1!=t.py || t.x!=t.px) && mas[t.y-1][t.x]==color)
		{
			if (vis[t.y-1][t.x]==1) {if (lev[t.y][t.x]!=lev[t.y-1][t.x]) tp=1;} else{
			vis[t.y-1][t.x]=1;
			lev[t.y-1][t.x]=lev[t.y][t.x];
			q[r].x=t.x;
			q[r].y=t.y-1;
			q[r].py=t.y;
			q[r].px=t.x;
			//q[r].level=t.level;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
		if (t.x<3*n-1 && (t.y+1!=t.py || t.x!=t.px) && mas[t.y+1][t.x]==color)
		{
			if (vis[t.y+1][t.x]==1) {if (lev[t.y][t.x]!=lev[t.y+1][t.x]) tp=1;} else{
			vis[t.y+1][t.x]=1;
			lev[t.y+1][t.x]=lev[t.y][t.x];
			q[r].x=t.x;
			q[r].y=t.y+1;
			q[r].py=t.y;
			q[r].px=t.x;
			//q[r].level=t.level;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
//----------------------cicle returns
		if (t.x==0 && (t.y!=t.py || 3*n-1!=t.px) && mas[t.y][3*n-1]==color)
		{
			if (vis[t.y][3*n-1]==1) {/*if (t.y==tny && 3*n-1==tnx)*/tp=1;} else{
			vis[t.y][3*n-1]=1;
			lev[t.y][3*n-1]=lev[t.y][t.x]-1;
			q[r].x=3*n-1;
			q[r].y=t.y;
			q[r].py=t.y;
			q[r].px=t.x;
			//q[r].level=t.level+1;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
		if (t.y==0 && (3*n-1!=t.py || t.x!=t.px)&& mas[3*n-1][t.x]==color)
		{
			if (vis[3*n-1][t.x]==1) {/*if (3*n-1==tny && t.x==tnx)*/tp=1;} else{
			vis[3*n-1][t.x]=1;
			lev[3*n-1][t.x]=lev[t.y][t.x]+1;
			q[r].x=t.x;
			q[r].y=3*n-1;
			q[r].py=t.y;
			q[r].px=t.x;
			//q[r].level=t.level+1;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
		if (t.x==3*n-1 && (t.y!=t.py || 0!=t.px) && mas[t.y][0]==color)
		{
			if (vis[t.y][0]==1) {/*if (t.y==tny && 0==tnx)*/tp=1;} else{
			vis[t.y][0]=1;
			lev[t.y][0]=lev[t.y][t.x]+1;
			q[r].x=0;
			q[r].y=t.y;
			q[r].py=t.y;
			q[r].px=t.x;
			//q[r].level=t.level+1;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
		if (t.y==3*n-1 && (0!=t.py || t.x!=t.px) && mas[0][t.x]==color)
		{
			if (vis[0][t.x]==1) {/*if (0==tny && t.x==tnx)*/ tp=1;} else{
			vis[0][t.x]=1;
			lev[0][t.x]=lev[t.y][t.x]-1;
			q[r].x=t.x;
			q[r].y=0;
			q[r].py=t.y;
			q[r].px=t.x;
			//q[r].level=t.level+1;
			r++;
			if (r>_qSize) r%=_qSize;}
		}
//---------------------
	}
}

int main()
{
	ifstream fin;
	ofstream fout;
	fin.open("input.txt",ios::in);
	fout.open("output.txt",ios::out);
	fin>>n;
	for (int i=0;i<n;i++)
	{
		for (int j=0;j<n;j++)
		{
			fin>>mas[i][j];
			mas[i][j+n]=mas[i][j+2*n]=mas[i+n][j]=mas[i][j];
			mas[i+n][j+n]=mas[i+n][j+2*n]=mas[i+2*n][j]=mas[i][j];
			mas[i+2*n][j+n]=mas[i+2*n][j+2*n]=mas[i][j];
			vis[i][j]=0;vis[i][j+n]=0;vis[i][j+2*n]=0;
			vis[i+n][j]=0;vis[i+n][j+n]=0;vis[i+n][j+2*n]=0;
			vis[i+2*n][j]=0;vis[i+2*n][j+n]=0;vis[i+2*n][j+2*n]=0;
		}
	}
	for (int i=0;i<256;i++) clr[i]=0;
	for (int i=n;i<2*n;i++)
	{
		for (int j=n;j<2*n;j++)
		{
			if (vis[i][j]==0) 
			{
			 //   i=16;
			 //	int j=21;
				int check=0;
				tnx=j;
				tny=i;
				bfs(i,j,mas[i][j],check);
				if (check){
					for (int k=0;k<3*n;k++)
					{
						if (mas[k][0]==mas[i][j] && mas[k][3*n-1]==mas[i][j] && vis[k][0]==1 && vis[k][3*n-1]==1) clr[mas[i][j]]=1;
						if (mas[0][k]==mas[i][j] && mas[3*n-1][k]==mas[i][j] && vis[0][k]==1 && vis[3*n-1][k]==1) clr[mas[i][j]]=1;
					}
				}
			} 
		}
	}
//----debug
/*	for (int i=0;i<3*n;i++)
	{
		if (i==n || i==2*n) fout<<endl;
		for (int j=0;j<3*n;j++)
		{
			if (j==n || j==2*n) fout<<' ';
			if (vis[i][j]==0) fout<<'0'; else fout<<'1';
		}
		fout<<endl;
	}*/
//----end_debug
/*	for (int i=0;i<3*n;i++)
	{
		if (mas[i][0]==mas[i][3*n-1] && vis[i][0]==1 && vis[i][3*n-1]==1) clr[mas[i][0]]=1;
		if (mas[0][i]==mas[3*n-1][i] && vis[0][i]==1 && vis[3*n-1][i]==1) clr[mas[0][i]]=1;
	}*/
	int cnt=0;
	for (int i=0;i<256;i++)
	{
		if (clr[i]) { fout<<char(i); cnt++; }
	}
	if (!cnt) fout<<"NO";
	fin.close();
	fout.close();
	return 0;
}